/*
 * Created on jul 20, 2005
 *
 * Copyright 2004 IDCA. All rights reserved.
 * IDCA PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package	com.idca.fsim.core.config;

import	com.idca.fsim.core.FsimContext;
import	com.mbuyu.foei.xml.AbstractXMLTagHandler;

import	org.xml.sax.Attributes;
import	org.xml.sax.SAXException;

/**
 * Handles the Tags of the config.
 * 
 * @author Willem Cazander
 * @version 1.0 20/07/2005
 */
public class FsimConfigTagHandler extends AbstractXMLTagHandler
{
	/** */
	private FsimContext fc = null;

	public FsimConfigTagHandler(FsimContext fc)
	{
		this.fc=fc;
		setTag("fsimConfig");
	}
	
	/**
	 * 
	 */
	public void startElement(String nameSpace,String tag,Attributes attributes) throws SAXException
	{
		if(getTag().equals(tag))
		{
			String name = attributes.getValue("name");
			//System.out.println("Setting name: "+name);
			fc.setName(name);
		}
	}
}