/*
 * Created on jul 20, 2005
 *
 * Copyright 2004 IDCA. All rights reserved.
 * IDCA PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package	com.idca.fsim.core.config;

import	com.idca.fsim.core.FsimContext;
import	com.mbuyu.foei.xml.AbstractXMLTagHandler;

import	org.xml.sax.Attributes;
import	org.xml.sax.SAXException;

import	java.util.EventListener;
import	java.util.logging.Logger;

/**
 * The Fsim Listeners
 * 
 * @author Willem Cazander
 * @version 1.0 20/07/2005
 */
public class ListenerTagHandler extends AbstractXMLTagHandler
{
	/** */
	private FsimContext fc = null;
	/** */
	private Logger logger = Logger.getLogger(this.getClass().getName());

	public ListenerTagHandler(FsimContext fc)
	{
		this.fc=fc;
		setTag("listener");
	}
	
	/**
	 * 
	 */
	public void startElement(String nameSpace,String tag,Attributes attributes) throws SAXException
	{
		if(getTag().equals(tag))
		{
			String className = attributes.getValue("class");

			Object object = null;
			Class objectClass = null;
			try {	
				objectClass = Class.forName(className);
				object = objectClass.newInstance();				
			} catch (ExceptionInInitializerError eie) {
			} catch (LinkageError lae) {
			} catch (InstantiationException ie) {
			} catch (IllegalAccessException iae) {
			} catch (ClassNotFoundException cnfe) {
			}
			System.out.println("adding listener: "+object);
			if(object instanceof EventListener) {
				fc.addListener((EventListener)object);
			}
		}
	}
}