/*
 * Created on jul 16, 2005
 *
 * Copyright 2004 IDCA. All rights reserved.
 * IDCA PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package	com.idca.fsim.core.config;

import	com.idca.fsim.core.FsimContext;
import com.idca.fsim.core.plugins.DBSearchSource;
import com.idca.fsim.core.plugins.Indexer;
import	com.idca.fsim.core.plugins.ResultCollector;
import	com.idca.fsim.core.plugins.ResultRenderer;
import com.idca.fsim.core.plugins.SearchSource;
import	com.idca.fsim.models.*;

import	com.mbuyu.foei.xml.AbstractXMLTagHandler;

import	org.xml.sax.Attributes;
import	org.xml.sax.SAXException;

import java.util.logging.Level;
import	java.util.logging.Logger;

/**
 * The SearchSources
 * 
 * @author Willem Cazander
 * @version 1.0 
 */
public class SearchSourceTagHandler extends AbstractXMLTagHandler
{
	/** */
	private FsimContext fc = null;
	/** */
	private Logger logger = Logger.getLogger(this.getClass().getName());

	public SearchSourceTagHandler(FsimContext fc)
	{
		this.fc=fc;
		setTag("searchSource");
	}
	
	/**
	 * 
	 */
	public void startElement(String nameSpace,String tag,Attributes attributes) throws SAXException
	{
		if(getTag().equals(tag))
		{
			DBSearchSource ss = new DBSearchSource();
			
			String name = attributes.getValue("name");
			String dbName = attributes.getValue("dbName");
			String tableName = attributes.getValue("tableName");
			String idColumnName = attributes.getValue("idColumnName");
			String searchColumnName = attributes.getValue("searchColumnName");
			String collector = attributes.getValue("resultCollector");
			String indexer = attributes.getValue("indexer");
			
			Object object = null;
			Class objectClass = null;
			try {	
				objectClass = Class.forName(collector);
				object = objectClass.newInstance();				
			} catch (ExceptionInInitializerError eie) {
			} catch (LinkageError lae) {
			} catch (InstantiationException ie) {
			} catch (IllegalAccessException iae) {
			} catch (ClassNotFoundException cnfe) {
			}
			if(object instanceof ResultCollector) {
				ss.setResultCollector((ResultCollector)object);
			}
			
			Object object2 = null;
			Class objectClass2 = null;
			try {	
				objectClass2 = Class.forName(indexer);
				object2 = objectClass2.newInstance();				
			} catch (Exception e) {
				logger.log(Level.WARNING,"Error with inder.",e);
			}
			if(object2 instanceof Indexer) {
				((Indexer)object2).setFsimContext(fc);
				ss.setIndexer((Indexer)object2);
			}
			
			
			String className = attributes.getValue("resultRenderer");

			object = null;
			objectClass = null;
			try {	
				objectClass = Class.forName(className);
				object = objectClass.newInstance();				
			} catch (ExceptionInInitializerError eie) {
			} catch (LinkageError lae) {
			} catch (InstantiationException ie) {
			} catch (IllegalAccessException iae) {
			} catch (ClassNotFoundException cnfe) {
			}
			if(object instanceof ResultRenderer) {
				ss.setResultRenderer((ResultRenderer)object);
			}
			
			
			
			
			
			object = null;

			ss.setName(name);
			ss.setDBName(dbName);
			ss.setTableName(tableName);
			ss.setIDColumnName(idColumnName);
			ss.setSearchColumnName(searchColumnName);
			fc.addSearchSource(ss);
		}
	}
}