
package com.idca.fsim.core.jdbc;

import java.sql.Connection;

/**
 * 
 * 
 * @author Willem Cazander
 * @version 1.0 Jan 4, 2006
 *
 * The ConnectionProvider is an interface which
 * lets objects returns a Connection.
 * 
 * We normally registrates an ConnectionProvider to the
 * ConnectionProviderManager so fsim can use it.
 * 
 */
public interface ConnectionProvider
{
	/**
	 * Gets the connection name for which this 
	 * ConnectionProvider handles connections. 
	 * @return Returns the connection name.
	 */
	public String getConnectionName();
	
	/**
	 * Gets an connection of this ConnectionProvider.
	 * @return Returns an Connection
	 */
	public Connection getConnection();
}