/*
 * Created on aug 2, 2005
 *
 * Copyright 2004 IDCA. All rights reserved.
 * IDCA PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package	com.idca.fsim.core.plugins;

import		com.idca.fsim.models.Hit;

import com.idca.fsim.core.WordLists;
import	com.idca.fsim.core.plugins.ResultCollector;
import	com.idca.fsim.core.plugins.ResultRenderer;
import	java.util.Collection;
import	java.util.Date;

/**
 * An Searchable Source
 * 
 * @author Willem Cazander
 * @version 1.0 
 */
public interface SearchSource 
{

	/**
	 * 
	 * @param name
	 */
	public void setName(String name);
	
	/**
	 * 
	 * @return
	 */
	public String getName();
	
	/**
	 * 
	 * 
	 * @return
	 */
	public WordLists getWordLists();
	
	/**
	 * 
	 * @param hit
	 */
	public void addHit(Hit hit);

	/**
	 * 
	 * @return
	 */
	public Collection getHits();
	
	/**
	 * 
	 * 
	 * @param id
	 * @return
	 */
	public Hit getHit(Long id);

	/**
	 * 
	 * 
	 * @param id
	 * @return
	 */
	public Hit getHit(long id);
	
	
	
	/**
	 * 
	 * @param resultCollector
	 */
	public void setResultCollector(ResultCollector resultCollector);

	
	/**
	 * 
	 * @return
	 */
	public ResultCollector getResultCollector();

	/**
	 * 
	 * 
	 * @param resultRenderer
	 */
	public void setResultRenderer(ResultRenderer resultRenderer);

	/**
	 * 
	 * 
	 * @return
	 */
	public ResultRenderer getResultRenderer();

	/**
	 * 
	 * 
	 * @param indexer
	 */
	public void setIndexer(Indexer indexer);
	
	/**
	 * 
	 * 
	 * @return
	 */
	public Indexer getIndexer();
	
	/**
	 * 
	 * @param lastIndexed
	 */
	public void setLastIndexed(Date lastIndexed);
	
	/**
	 * 
	 * @return
	 */
	public Date getLastIndexed();
	
	/**
	 * 
	 * 
	 * @return
	 */
	public Hit getLastIndexedHit();
	
	/**
	 * 
	 * 
	 * @return
	 */
	public long getLastIndexedHitID();
}
