/*
 * 
 * 
 */

package	com.idca.fsim.searchers.files;

import	com.idca.fsim.core.plugins.listeners.FsimContextListener;
import	com.idca.fsim.core.plugins.listeners.FsimContextEvent;
import	com.idca.fsim.core.FsimContext;

import	java.util.logging.Logger;

/**
 * Does caching of the hosts an paths.
 * 
 * @author Willem Cazander
 * @version 1.0 19/07/2005
 */
public class FilesListener implements FsimContextListener
{
	/** */
	static PathManager pathManager = null;
	/** */
	private Logger logger = Logger.getLogger(FilesListener.class.getName());
	
	/**
	 * 
	 * @return
	 */
	static public PathManager getPathManager()
	{
		return pathManager;
	}
	
	public void contextInitialized(FsimContextEvent contextEvent)
	{
		FsimContext fc = contextEvent.getFsimContext();
		if(pathManager==null)
		{
			pathManager = new PathManager(fc,"fsim_dba");
		}
		pathManager.updatePaths();

	}
	
	public void contextDestroyed(FsimContextEvent contextEvent)
	{
		FsimContext fc = contextEvent.getFsimContext();
		logger.info(".... JUST got destry event "+fc.getName());
	}
	
}
