/*
 * 
 * 
 */

package	com.idca.fsim.searchers.files.collectors;

import	com.idca.fsim.core.FsimContext;
import	com.idca.fsim.core.plugins.AbstractResultCollector;
import	com.idca.fsim.models.Hit;
import com.idca.fsim.models.ModelHitTuble;
import	com.idca.fsim.searchers.files.PathManager;
import	com.idca.fsim.searchers.files.FilesListener;
import	com.idca.fsim.searchers.files.models.Path;

import	java.util.List;
import	java.util.ArrayList;
import	java.util.Collection;
import	java.util.Iterator;

/**
 * Returns the Path search results.
 * 
 * @author Willem Cazander
 * @version 1.0 Jan 22, 2006
 *
 */
public class PathResultCollector extends AbstractResultCollector
{	
	public List getResults(List hits,FsimContext fsimContext,List result)
	{
		PathManager pm = FilesListener.getPathManager();
		if(hits.size()==0) {
			return result;
		}
		
		Iterator i = hits.iterator();
		while(i.hasNext())
		{
			Hit hit = (Hit)i.next();
			Path path = pm.getPath(hit.id);
			if(path!=null)
			{
				result.add(new ModelHitTuble(hit,path));
			}
			else
			{	
				// mm non valid path ID ...	
			}
		}
		return result;
	}
}
