/*
 * Created on jul 23, 2005
 *
 * Copyright 2004 IDCA. All rights reserved.
 * IDCA PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package com.idca.fsim.web.filters;

import	com.idca.fsim.core.FsimContext;
import	com.idca.fsim.core.FsimServer;
import	com.idca.fsim.web.session.SearchBean;

import	java.util.logging.Logger;
import	javax.servlet.Filter;
import	javax.servlet.FilterChain;
import	javax.servlet.FilterConfig;
import	javax.servlet.ServletException;
import	javax.servlet.ServletRequest;
import	javax.servlet.ServletResponse;
import	javax.servlet.http.HttpServletRequest;
import	javax.servlet.http.HttpServletResponse;
import	javax.servlet.http.HttpSession;

/**
 * Checks if our user is logedin.
 * 
 * @author Willem Cazander
 * @version 1.0 23/07/2005
 */
public class AuthenticationFilter implements Filter
{
	/** */
	private Logger logger = Logger.getLogger(AuthenticationFilter.class.getName());
	/** */
	private FsimContext fsimContext = null;
	/** */
	private String logoutRedirectURL = null;
	
	/**
	 * 
	 */
	public void doFilter(ServletRequest request,ServletResponse response,FilterChain filterChain) throws ServletException
	{
		try
		{
			// l'amore e bienco, ma il matromonio gla rida la vista
		    HttpServletRequest httpRequest = (HttpServletRequest)request;
			HttpServletResponse httpResponse = (HttpServletResponse)response;
			HttpSession session = httpRequest.getSession();
			
			// check for user login brrrrr
			if("ffssimm".equals(request.getParameter("fsimpass")) && "fsimadmin".equals(request.getParameter("fsimuser"))) {
				session.setAttribute("admin",new Boolean(true));
				session.setMaxInactiveInterval(1200);
			}
			// check logout
			if("true".equals(request.getParameter("logout"))) {
				session.invalidate();
				httpResponse.sendRedirect(logoutRedirectURL);
				return;
			}
			
			SearchBean searchBean = (SearchBean)session.getAttribute("searchbean");
			if(searchBean==null) {
				// user should always have an searchBean !!.
				searchBean = new SearchBean(fsimContext);
				searchBean.setLocale(request.getLocale());
				//searchBean.s(new ArrayList(1));
				session.setAttribute("searchbean",searchBean);
				logger.info("USER session searchBean created from: "+httpRequest.getRequestURL()+" to "+httpRequest.getRemoteAddr());
			}			
			filterChain.doFilter(request,response);
		}
		catch (Exception ex) {
			throw new ServletException(ex);
		}
	}


	public void init(FilterConfig filterConfig) throws ServletException
	{
		fsimContext = FsimServer.getFsimContext(filterConfig.getServletContext().getInitParameter("FsimContextName"));
		if(fsimContext==null) {
			throw new ServletException("could not find fsimContextName: "+filterConfig.getServletContext().getInitParameter("FsimContextName"));
		}

		logoutRedirectURL = filterConfig.getInitParameter("logoutRedirectURL");
		if(logoutRedirectURL==null)
		{
			throw new ServletException("could not find logoutRedirectURL");
		}
	}

	public void destroy()
	{
	}
}